-- RightShifter24
-- DataをnShift分右に、丸めを行いつつシフトする for FADD
-- Dataは "MSB & N数の仮数部"、また、末尾にGbitとRbitをつける

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity RightShifter24 is

	port(Data    : in std_logic_vector(23 downto 0);
	     nShift  : in std_logic_vector(7 downto 0);
	     Shifted : out std_logic_vector(25 downto 0));

end RightShifter24;

architecture STRUCTURE of RightShifter24 is

signal InD1, InD2, InD3, InD4, InD5 , InD0 : std_logic_vector(31 downto 0);   
--signal InD6,InD7,InD8 : std_logic_vector(31 downto 0);

begin -- STRUCTURE
       InD0 <= "00000000000000000000000000000000" when nShift(7 downto 5) /= 0 else
               Data & "00000000";  
       InD1 <= InD0(31 downto 0) when nShift(4) = '0' else
               "0000000000000000" & InD0(31 downto 16);
       InD2 <= InD1(31 downto 0) when nShift(3) = '0' else
               "00000000" & InD1(31 downto 8);
       InD3 <= InD2(31 downto 0) when nShift(2) = '0' else
               "0000" & InD2(31 downto 4);
       InD4 <= InD3(31 downto 0) when nShift(1) = '0' else
               "00" & InD3(31 downto 2);
       InD5 <= InD4(31 downto 0) when nShift(0) = '0' else
               "0" & InD4(31 downto 1);
       Shifted <= InD5(31 downto 6);  
    
    
--   Shifted <= Data & "00"
--                when nShift = "00000000" else
--              '0' & Data & '0'
--                when nShift = "00000001" else
--              "00" & Data
--                when nShift = "00000010" else
--              "000" & Data(23 downto 1) --& (Data(1) or (Data(0)))
--                when nShift = "00000011" else
--              "0000" & Data(23 downto 2) --& (Data(2) or Data(1) or (Data(0)))
--                when nShift = "00000100" else
--              "00000" & Data(23 downto 3) --& (Data(3) or Data(2) or Data(1) or (Data(0)))
--                when nShift = "00000101" else
--              "000000" & Data(23 downto 4) --& (Data(4) or Data(3) or Data(2) or Data(1) or (Data(0)))
--                when nShift = "00000110" else
--              "0000000" & Data(23 downto 5) --& (Data(5) or Data(4) or Data(3) or Data(2) or Data(1) or (Data(0)))
--                when nShift = "00000111" else
--              "00000000" & Data(23 downto 6) --& (Data(6) or Data(5) or Data(4) or Data(3) or Data(2) or Data(1) or (Data(0)))
--                when nShift = "00001000" else
--              "000000000" & Data(23 downto 7) --& (Data(7) or Data(6) or Data (5) or Data(4) or Data(3) or Data(2) or Data(1) or (Data(0)))
--                when nShift = "00001001" else
--              "0000000000" & Data(23 downto 8) --& (Data(8) or Data(7) or Data(6) or Data (5) or Data(4) or Data(3) or Data(2) or Data(1) or (Data(0)))
--                when nShift = "00001010" else
--              "00000000000" & Data(23 downto 9) --& (Data(9) or Data(8) or Data(7) or Data(6) or Data (5) or Data(4) or Data(3) or Data(2) or Data(1) or (Data(0)))
--                when nShift = "00001011" else
--              "000000000000" & Data(23 downto 10) --& (Data(10) or Data(9) or Data(8) or Data(7) or Data(6) or Data (5) or Data(4) or Data(3) or Data(2) or Data(1) or (Data(0)))
--                when nShift = "00001100" else
--              "0000000000000" & Data(23 downto 11) --& (Data(11) or Data(10) or Data(9) or Data(8) or Data(7) or Data(6) or Data (5) or Data(4) or Data(3) or Data(2) or Data(1) or (Data(0)))
--                when nShift = "00001101" else
--              "00000000000000" & Data(23 downto 12) --& (Data(12) or Data(11) or Data(10) or Data(9) or Data(8) or Data(7) or Data(6) or Data (5) or Data(4) or Data(3) or Data(2) or Data(1) or (Data(0)))
--                when nShift = "00001110" else
--              "000000000000000" & Data(23 downto 13) --& (Data(13) or Data(12) or Data(11) or Data(10) or Data(9) or Data(8) or Data(7) or Data(6) or Data (5) or Data(4) or Data(3) or Data(2) or Data(1) or (Data(0)))
--                when nShift = "00001111" else
--              "0000000000000000" & Data(23 downto 14) --& (Data(14) or Data(13) or Data(12) or Data(11) or Data(10) or Data(9) or Data(8) or Data(7) or Data(6) or Data (5) or Data(4) or Data(3) or Data(2) or Data(1) or (Data(0)))
--                when nShift = "00010000" else
--              "00000000000000000" & Data(23 downto 15) --& (Data(15) or Data(14) or Data(13) or Data(12) or Data(11) or Data(10) or Data(9) or Data(8) or Data(7) or Data(6) or Data (5) or Data(4) or Data(3) or Data(2) or Data(1) or (Data(0)))
--                when nShift = "00010001" else
--              "000000000000000000" & Data(23 downto 16) --& (Data(16) or Data(15) or Data(14) or Data(13) or Data(12) or Data(11) or Data(10) or Data(9) or Data(8) or Data(7) or Data(6) or Data (5) or Data(4) or Data(3) or Data(2) or Data(1) or (Data(0)))
--                when nShift = "00010010" else
--              "0000000000000000000" & Data(23 downto 17) --& (Data(17) or Data(16) or Data(15) or Data(14) or Data(13) or Data(12) or Data(11) or Data(10) or Data(9) or Data(8) or Data(7) or Data(6) or Data (5) or Data(4) or Data(3) or Data(2) or Data(1) or (Data(0)))
--                when nShift = "00010011" else
--              "00000000000000000000" & Data(23 downto 18) --& (Data(18) or Data(17) or Data(16) or Data(15) or Data(14) or Data(13) or Data(12) or Data(11) or Data(10) or Data(9) or Data(8) or Data(7) or Data(6) or Data (5) or Data(4) or Data(3) or Data(2) or Data(1) or (Data(0)))
--                when nShift = "00010100" else
--              "000000000000000000000" & Data(23 downto 19) --& (Data(19) or Data(18) or Data(17) or Data(16) or Data(15) or Data(14) or Data(13) or Data(12) or Data(11) or Data(10) or Data(9) or Data(8) or Data(7) or Data(6) or Data (5) or Data(4) or Data(3) or Data(2) or Data(1) or (Data(0)))
--                when nShift = "00010101" else
--              "0000000000000000000000" & Data(23 downto 20) --& (Data(20) or Data(19) or Data(18) or Data(17) or Data(16) or Data(15) or Data(14) or Data(13) or Data(12) or Data(11) or Data(10) or Data(9) or Data(8) or Data(7) or Data(6) or Data (5) or Data(4) or Data(3) or Data(2) or Data(1) or (Data(0)))
--                when nShift = "00010110" else
--              "00000000000000000000000" & Data(23 downto 21) --& (Data(21) or Data(20) or Data(19) or Data(18) or Data(17) or Data(16) or Data(15) or Data(14) or Data(13) or Data(12) or Data(11) or Data(10) or Data(9) or Data(8) or Data(7) or Data(6) or Data (5) or Data(4) or Data(3) or Data(2) or Data(1) or (Data(0)))
--                when nShift = "00010111" else
--              "000000000000000000000000" & Data(23 downto 22) --& (Data(22) or Data(21) or Data(20) or Data(19) or Data(18) or Data(17) or Data(16) or Data(15) or Data(14) or Data(13) or Data(12) or Data(11) or Data(10) or Data(9) or Data(8) or Data(7) or Data(6) or Data (5) or Data(4) or Data(3) or Data(2) or Data(1) or (Data(0)))
--                when nShift = "00011000" else
--              "0000000000000000000000000" & Data(23)--(Data(23) or Data(22) or Data(21) or Data(20) or Data(19) or Data(18) or Data(17) or Data(16) or Data(15) or Data(14) or Data(13) or Data(12) or Data(11) or Data(10) or Data(9) or Data(8) or Data(7) or Data(6) or Data (5) or Data(4) or Data(3) or Data(2) or Data(1) or (Data(0)));
--                when nShift = "00011001" else
--              "00000000000000000000000000";

end STRUCTURE;
