-- F_ADSB
-- ソースオペランドの符号を判定して
-- FADD_SもしくはFSUB_Sに渡す

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity F_ADSB is

	port(SRC1,SRC2   : in std_logic_vector(31 downto 0);
	     FUNC        : in std_logic_vector(3 downto 0);
        CLK         : in std_logic;
        FADSB_START : in std_logic;
        FADSB_END   : out std_logic;
	     OUTPUT      : out std_logic_vector(31 downto 0));

end F_ADSB;

architecture STRUCTURE of F_ADSB is
----　↓パイプライン用
--   signal W_exp_in       : std_logic_vector(7 downto 0);
--   signal MANT_buf2_in   : std_logic_vector(26 downto 0);
--   signal Neq_in         : std_logic;
--   signal SRC1_1_in      : std_logic_vector(31 downto 0);
--   signal SRC2_1_in      : std_logic_vector(31 downto 0);
--   signal W_exp_out      : std_logic_vector(7 downto 0);
--   signal MANT_buf2_out  : std_logic_vector(26 downto 0);
--   signal Neq_out        : std_logic;
--   signal SRC1_1_out     : std_logic_vector(31 downto 0);
--   signal SRC2_1_out     : std_logic_vector(31 downto 0);
--   signal FUNC2_in       : std_logic;
--   signal FUNC2_out      : std_logic;
--　↑パイプライン用

--　↓非パイプライン用
   signal W_exp          : std_logic_vector(7 downto 0);
   signal MANT_buf2      : std_logic_vector(26 downto 0);
   signal Neq            : std_logic;
   signal SRC1_1         : std_logic_vector(31 downto 0);
   signal SRC2_1         : std_logic_vector(31 downto 0);
   signal FUNC2          : std_logic;
--　↑非パイプライン用


   component F_ADSB_1
	port(SRC1,SRC2  : in std_logic_vector(31 downto 0);
	     FUNC       : in std_logic_vector(3 downto 0);
        MANT_buf2  : out std_logic_vector(26 downto 0);
        Neq        : out std_logic;
        W_exp      : out std_logic_vector(7 downto 0);
        FUNC2      : out std_logic;
        SRC1_1,SRC2_1  : out std_logic_vector(31 downto 0)
	);
   end component;
   component F_ADSB_2
	port(MANT_buf2      : in std_logic_vector(26 downto 0);
        Neq            : in std_logic;
        W_exp          : in std_logic_vector(7 downto 0);
        FUNC2          : in std_logic;
        SRC1_1,SRC2_1  : in std_logic_vector(31 downto 0);
	     OUTPUT         : out std_logic_vector(31 downto 0));
   end component;

begin -- STRUCTURER
--　↓非パイプライン実行用
   F_ADSB_1_1 : F_ADSB_1 port map (SRC1,SRC2,FUNC,MANT_buf2,Neq,W_exp,FUNC2,SRC1_1,SRC2_1);
   F_ADSB_2_1 : F_ADSB_2 port map (MANT_buf2,Neq,W_exp,FUNC2,SRC1_1,SRC2_1,OUTPUT);

   FADD_FSUB : process(CLK)
   begin
      if CLK'event and CLK = '1' then
      end if;
      if CLK'event and CLK = '0' then
         FADSB_END <= FADSB_START;
      end if;
   end process FADD_FSUB;


--　↑非パイプライン実行用

--　↓パイプライン用
--   F_ADSB_1_1 : F_ADSB_1 port map (SRC1,SRC2,FUNC,MANT_buf2_out,Neq_out,W_exp_out,FUNC2_out,SRC1_1_out,SRC2_1_out);
--   F_ADSB_2_1 : F_ADSB_2 port map (MANT_buf2_in,Neq_in,W_exp_in,FUNC2_in,SRC1_1_in,SRC2_1_in,OUTPUT);
--
--
--   FADD_FSUB : process(CLK)
--   begin
--      if CLK'event and CLK = '1' then
--         MANT_buf2_in <= MANT_buf2_out;
--         Neq_in <= Neq_out;
--         W_exp_in <= W_exp_out;
--         SRC1_1_in <= SRC1_1_out;
--         SRC2_1_in <= SRC2_1_out;
--         FUNC2_in <= FUNC2_out;
--      end if;
--      if CLK'event and CLK = '0' then
--         FADSB_END <= FADSB_START;
--      end if;
--   end process FADD_FSUB;
--　↑パイプライン用

end STRUCTURE;
