-- FINVSQRTの繰り返し計算部分
-- X(n+1) = (3 - A*X(n)*X(n))*X(n)/2を行う
-- 

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity FINVSQRT_repeat_2 is

	port(EXPin          : in std_logic_vector(7 downto 0);
             Zeroin         : in std_logic;
	     Xhin           : in std_logic_vector(12 downto 0);
             Xlin           : in std_logic_vector(11 downto 0);
             Ain            : in std_logic_vector(22 downto 0);
	     AXin           : in std_logic_vector(29 downto 0);
             EXPout         : out std_logic_vector(7 downto 0);
             Zeroout        : out std_logic;
	     Xhout          : out std_logic_vector(12 downto 0);
             Xlout          : out std_logic_vector(11 downto 0);
             Aout   : out std_logic_vector(22 downto 0);
	     ThreeMinusAXX  : out std_logic_vector(27 downto 0));

end FINVSQRT_repeat_2;

architecture STRUCTURE of FINVSQRT_repeat_2 is

signal AXX : std_logic_vector(54 downto 0);        -- A*X(n)*X(n)
signal AXX_buf : std_logic_vector(54 downto 0);

begin -- STRUCTURE

AXX_buf <= (Xhin & Xlin) * AXin;

AXX <= AXX_buf(53 downto 0) & '0' when AXX_buf(54 downto 53) = "00" else AXX_buf;
-- AXX_bufの頭は"001"か"01"か'1'（掛け算により、先頭の'1'が最大で1つ右にずれる）

ThreeMinusAXX <= "1100000000000000000000000000" - ('0' & AXX(54 downto 28));
Xhout <= Xhin;
Xlout <= Xlin;
EXPout <= EXPin;
Zeroout <= Zeroin;
Aout <= Ain;

end STRUCTURE;
