-- Priority Encoder 31
-- 31bit入力のプライオリティエンコーダ
-- MSBの位置を出力

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity Priority31_sub is

	port(bits       : in std_logic_vector(31 downto 0);
	     Code_out   : out std_logic_vector(4 downto 0));

end Priority31_sub;

architecture STRUCTURE of Priority31_sub is
component Priority3
       port(bits     : in std_logic_vector(3 downto 0);
            Code_out : out std_logic_vector(1 downto 0));
end component;

signal C1 : std_logic_vector(7 downto 0);
signal C2 : std_logic;
signal C3_1, C3_2 : std_logic_vector(1 downto 0);
signal C4 : std_logic_vector(1 downto 0);
signal C5_1, C5_2 : std_logic_vector(1 downto 0);
signal D1, D2, D3, D4, D5, D6, D7, D8 : std_logic_vector(1 downto 0);
begin -- STRUCTURE

C1(7) <= bits(31) or bits(30) or bits(29) or bits(28);
C1(6) <= bits(27) or bits(26) or bits(25) or bits(24);
C1(5) <= bits(23) or bits(22) or bits(21) or bits(20);
C1(4) <= bits(19) or bits(18) or bits(17) or bits(16);
C1(3) <= bits(15) or bits(14) or bits(13) or bits(12);
C1(2) <= bits(11) or bits(10) or bits(9)  or bits(8);
C1(1) <= bits(7)  or bits(6)  or bits(5)  or bits(4);
C1(0) <= bits(3)  or bits(2)  or bits(1)  or bits(0);

C2 <= C1(7) or C1(6) or C1(5) or C1(4);

Priority3_1  : Priority3 port map (bits(31 downto 28),D1);
Priority3_2  : Priority3 port map (bits(27 downto 24),D2);
Priority3_3  : Priority3 port map (bits(23 downto 20),D3);
Priority3_4  : Priority3 port map (bits(19 downto 16),D4);
Priority3_5  : Priority3 port map (bits(15 downto 12),D5);
Priority3_6  : Priority3 port map (bits(11 downto  8),D6);
Priority3_7  : Priority3 port map (bits(7  downto  4),D7);
Priority3_8  : Priority3 port map (bits(3  downto  0),D8);
Priority3_9  : Priority3 port map (C1(7 downto 4),C3_1);
Priority3_10 : Priority3 port map (C1(3 downto 0),C3_2);

C4 <= C3_1 when C2 = '1' else
      C3_2;

C5_1 <= D1 when C3_1 = "11" else 
        D2 when C3_1 = "10" else 
        D3 when C3_1 = "01" else 
        D4;

--C5_2 <= D5 when C3_1 = "11" else 
--        D6 when C3_1 = "10" else 
--        D7 when C3_1 = "01" else 
--        D8;
C5_2 <= D5 when C3_2 = "11" else 
        D6 when C3_2 = "10" else 
        D7 when C3_2 = "01" else 
        D8;

Code_out(4) <= C2;
Code_out(3 downto 2) <= C4;
Code_out(1 downto 0) <= C5_1 when C2 = '1' else
                        C5_2;











   --Code(4) <= bits(31) or bits(30) or bits(29) or bits(28) or bits(27) or bits(26) or bits(25) or bits(24) or bits(23) or bits(22) or bits(21) or bits(20) or bits(19) or bits(18) or bits(17) or bits(16);

   --Code3_1 <= bits(31) or bits(30) or bits(29) or bits(28) or bits(27) or bits(26) or bits(25) or bits(24);
   --Code3_0 <= bits(15) or bits(14) or bits(13) or bits(12) or bits(11) or bits(10) or bits(9) or bits(8);
   --Code(3) <= Code3_1 when Code(4) = '1' else
   --           Code3_0;

   --Code2_3 <= bits(31) or bits(30) or bits(29) or bits(28);
   --Code2_2 <= bits(23) or bits(22) or bits(21) or bits(20);
   --Code2_1 <= bits(15) or bits(14) or bits(13) or bits(12);
   --Code2_0 <= bits(7) or bits(6) or bits(5) or bits(4);

   --Code(2) <= Code2_3 when Code(4 downto 3) = "11" else
   --           Code2_2 when Code(4 downto 3) = "10" else
   --           Code2_1 when Code(4 downto 3) = "01" else
   --           Code2_0;

   --Code1_7 <= bits(31) or bits(30);
   --Code1_6 <= bits(27) or bits(26);
   --Code1_5 <= bits(23) or bits(22);
   --Code1_4 <= bits(19) or bits(18);
   --Code1_3 <= bits(15) or bits(14);
   --Code1_2 <= bits(11) or bits(10);
   --Code1_1 <= bits(7) or bits(6);
   --Code1_0 <= bits(3) or bits(2);

   --Code(1) <= Code1_7 when Code(4 downto 2) = "111" else
   --           Code1_6 when Code(4 downto 2) = "110" else
   --           Code1_5 when Code(4 downto 2) = "101" else
   --           Code1_4 when Code(4 downto 2) = "100" else
   --           Code1_3 when Code(4 downto 2) = "011" else
   --           Code1_2 when Code(4 downto 2) = "010" else
   --           Code1_1 when Code(4 downto 2) = "001" else
   --           Code1_0;

   --Code(0) <= bits(31) when Code(4 downto 1) = "1111" else
   --           bits(29) when Code(4 downto 1) = "1110" else
   --           bits(27) when Code(4 downto 1) = "1101" else
   --           bits(25) when Code(4 downto 1) = "1100" else
   --           bits(23) when Code(4 downto 1) = "1011" else
   --           bits(21) when Code(4 downto 1) = "1010" else
   --           bits(19) when Code(4 downto 1) = "1001" else
   --           bits(17) when Code(4 downto 1) = "1000" else
   --           bits(15) when Code(4 downto 1) = "0111" else
   --           bits(13) when Code(4 downto 1) = "0110" else
   --           bits(11) when Code(4 downto 1) = "0101" else
   --           bits(9) when Code(4 downto 1) = "0100" else
   --           bits(7) when Code(4 downto 1) = "0011" else
   --           bits(5) when Code(4 downto 1) = "0010" else
   --           bits(3) when Code(4 downto 1) = "0001" else
   --           bits(1);
   --Code_out <= Code;
   
   
   
--   	  Code_out(4) <= bits(30) or bits(29) or bits(28) or bits(27) or bits(26)
--	              or bits(25) or bits(24) or bits(23) or bits(22) or bits(21)
--	              or bits(20) or bits(19) or bits(18) or bits(17) or bits(16) or bits(15);
--	   Code_out(3) <= bits(30) or bits(29) or bits(28) or bits(27) or 
--	              bits(26) or bits(25) or bits(24) or bits(23) or
--	              (not bits(22) and not bits(21) and not bits(20) and not bits(19) and
--	              not bits(18) and not bits(17) and not bits(16) and not bits(15) and
--	              (bits(14) or bits(13) or bits(12) or bits(11) or 
--	              bits(10) or bits(9) or bits(8) or bits(7)));
--		Code_out(2) <= bits(30) or bits(29) or bits(28) or bits(27) or
--		           (not bits(26) and not bits(25) and not bits(24) and not bits(23) and
--		           (bits(22) or bits(21) or bits(20) or bits(19) or
--		           (not bits(18) and not bits(17) and not bits(16) and not bits(15) and
--		           (bits(14) or bits(13) or bits(12) or bits(11) or
--		           (not bits(10) and not bits(9) and not bits(8) and not bits(7) and
--		           (bits(6) or bits(5) or bits(4) or bits(3)))))));
--		Code_out(1) <= bits(30) or bits(29) or (not bits(28) and not bits(27) and
--		           (bits(26) or bits(25) or (not bits(24) and not bits(23) and
--		           (bits(22) or bits(21) or (not bits(20) and not bits(19) and
--		           (bits(18) or bits(17) or (not bits(16) and not bits(15) and
--		           (bits(14) or bits(13) or (not bits(12) and not bits(11) and
--		           (bits(10) or bits(9) or (not bits(8) and not bits(7) and
--		           (bits(6) or bits(5) or (not bits(4) and not bits(3) and
--		           (bits(2) or bits(1)))))))))))))));
--	   Code_out(0) <= bits(30) or (not bits(29) and (bits(28) or (not bits(27) and
--	              (bits(26) or (not bits(25) and (bits(24) or (not bits(23) and
--	              (bits(22) or (not bits(21) and (bits(20) or (not bits(19) and
--	              (bits(18) or (not bits(17) and (bits(16) or (not bits(15) and
--	              (bits(14) or (not bits(13) and (bits(12) or (not bits(11) and
--	              (bits(10) or (not bits(9) and (bits(8) or (not bits(7) and
--	              (bits(6) or (not bits(5) and (bits(4) or (not bits(3) and
--	              (bits(2) or (not bits(1) and (bits(0)))))))))))))))))))))))))))))));  
   
   

--
--   Code_out <= --"11111" when bits(31) = '1' else -- bits(31) cannot be '1' (because of "itof","fsub_s")
--               "11110" when bits(30) = '1' else
--               "11101" when bits(29) = '1' else
--               "11100" when bits(28) = '1' else
--               "11011" when bits(27) = '1' else
--               "11010" when bits(26) = '1' else
--               "11001" when bits(25) = '1' else
--               "11000" when bits(24) = '1' else
--               "10111" when bits(23) = '1' else
--               "10110" when bits(22) = '1' else
--               "10101" when bits(21) = '1' else
--               "10100" when bits(20) = '1' else
--               "10011" when bits(19) = '1' else
--               "10010" when bits(18) = '1' else
--               "10001" when bits(17) = '1' else
--               "10000" when bits(16) = '1' else
--               "01111" when bits(15) = '1' else
--               "01110" when bits(14) = '1' else
--               "01101" when bits(13) = '1' else
--               "01100" when bits(12) = '1' else
--               "01011" when bits(11) = '1' else
--               "01010" when bits(10) = '1' else
--               "01001" when bits(9) =  '1' else
--               "01000" when bits(8) =  '1' else
--               "00111" when bits(7) =  '1' else
--               "00110" when bits(6) =  '1' else
--               "00101" when bits(5) =  '1' else
--               "00100" when bits(4) =  '1' else
--               "00011" when bits(3) =  '1' else
--               "00010" when bits(2) =  '1' else
--               "00001" when bits(1) =  '1' else
--               "00000";




--   size 21 36 35 0%     12.732ns                       
--   C <= bits(30) or bits(29) or bits(28) or bits(27) or bits(26) -- bits(31) cannot be '1'
--	                 or bits(25) or bits(24) or bits(23) or bits(22) or bits(21)
--	                 or bits(20) or bits(19) or bits(18) or bits(17) or bits(16);
--   Code <=     "1111" when bits(15) = '1' else
--               "1110" when bits(14) = '1' or bits(30) = '1' else
--               "1101" when bits(13) = '1' or bits(29) = '1' else
--               "1100" when bits(12) = '1' or bits(28) = '1' else
--               "1011" when bits(11) = '1' or bits(27) = '1' else
--               "1010" when bits(10) = '1' or bits(26) = '1' else
--               "1001" when bits(9) =  '1' or bits(25) = '1' else
--               "1000" when bits(8) =  '1' or bits(24) = '1' else
--               "0111" when bits(7) =  '1' or bits(23) = '1' else
--               "0110" when bits(6) =  '1' or bits(22) = '1' else
--               "0101" when bits(5) =  '1' or bits(21) = '1' else
--               "0100" when bits(4) =  '1' or bits(20) = '1' else
--               "0011" when bits(3) =  '1' or bits(19) = '1' else
--               "0010" when bits(2) =  '1' or bits(18) = '1' else
--               "0001" when bits(1) =  '1' or bits(17) = '1' else
--               "0000";
--   Code_out <= C & Code;


--   size 10 18 35 0%     time 10.888ns
--   C1 <= bits(30) or bits(29) or bits(28) or bits(27) or bits(26) -- bits(31) cannot be '1'
--	                 or bits(25) or bits(24) or bits(23) or bits(22) or bits(21)
--	                 or bits(20) or bits(19) or bits(18) or bits(17) or bits(16);
--	C2 <= bits(30) or bits(29) or bits(28) or bits(27) or 
--	              bits(26) or bits(25) or bits(24) or
--	              (not bits(23) and not bits(22) and not bits(21) and not bits(20) and
--	              not bits(19) and not bits(18) and not bits(17) and not bits(16) and
--	              (bits(15) or bits(14) or bits(13) or bits(12) or 
--	              bits(11) or bits(10) or bits(9) or bits(8)));
--   Code <=     "110" when bits(30) = '1' else
--               "101" when bits(29) = '1' else
--               "100" when bits(28) = '1' else
--               "011" when bits(27) = '1' else
--               "010" when bits(26) = '1' else
--               "001" when bits(25) = '1' else
--               "000" when bits(24) = '1' else
--               "111" when bits(23) = '1' else
--               "110" when bits(22) = '1' else
--               "101" when bits(21) = '1' else
--               "100" when bits(20) = '1' else
--               "011" when bits(19) = '1' else
--               "010" when bits(18) = '1' else
--               "001" when bits(17) = '1' else
--               "000" when bits(16) = '1' else
--               "111" when bits(15) = '1' else
--               "110" when bits(14) = '1' else
--               "101" when bits(13) = '1' else
--               "100" when bits(12) = '1' else
--               "011" when bits(11) = '1' else
--               "010" when bits(10) = '1' else
--               "001" when bits(9) = '1' else
--               "000" when bits(8) = '1' else
--               "111" when bits(7) = '1' else
--               "110" when bits(6) = '1' else
--               "101" when bits(5) = '1' else
--               "100" when bits(4) = '1' else
--               "011" when bits(3) = '1' else
--               "010" when bits(2) = '1' else
--               "001" when bits(1) = '1' else
--               "000";
--   Code_out <= C1 & C2 & Code;     
    
                        
end STRUCTURE;
